diff -uNr a/configure.ac b/configure.ac
--- a/configure.ac	2013-05-22 17:35:08.000000000 +0100
+++ b/configure.ac	2013-05-22 21:36:04.000000000 +0100
@@ -68,6 +68,7 @@
 GIO_MIN_VERSION=2.29.10
 POLKIT_MIN_VERSION=0.100
 STARTUP_NOTIFICATION_MIN_VERSION=0.11
+GNOME_DESKTOP_MIN_VERSION=3.0.0
 
 # Collect more than 20 libraries for a prize!
 PKG_CHECK_MODULES(CINNAMON, gio-2.0 >= $GIO_MIN_VERSION
@@ -82,7 +83,8 @@
                                gobject-introspection-1.0 >= $GOBJECT_INTROSPECTION_MIN_VERSION
 			       libcanberra
                                polkit-agent-1 >= $POLKIT_MIN_VERSION xfixes
-                               libnm-glib libnm-util gnome-keyring-1)
+                               libnm-glib libnm-util gnome-keyring-1
+                               gnome-desktop-3.0 >= GNOME_DESKTOP_MIN_VERSION)
 
 PKG_CHECK_MODULES(CINNAMON_PERF_HELPER, gtk+-3.0 gio-2.0)
 
@@ -106,7 +108,8 @@
 CFLAGS=$saved_CFLAGS
 LIBS=$saved_LIBS
 
-PKG_CHECK_MODULES(ST, clutter-1.0 gtk+-3.0 libcroco-0.6 >= 0.6.2 gnome-desktop-3.0 >= 2.90.0 x11)
+PKG_CHECK_MODULES(ST, clutter-1.0 gtk+-3.0 libcroco-0.6 >= 0.6.2 
+                      gnome-desktop-3.0 >= GNOME_DESKTOP_MIN_VERSION x11)
 PKG_CHECK_MODULES(GDMUSER, dbus-glib-1 gtk+-3.0)
 PKG_CHECK_MODULES(TRAY, gtk+-3.0)
 PKG_CHECK_MODULES(GVC, libpulse libpulse-mainloop-glib gobject-2.0)
diff -uNr a/data/org.cinnamon.gschema.xml.in b/data/org.cinnamon.gschema.xml.in
--- a/data/org.cinnamon.gschema.xml.in	2013-05-22 17:35:08.000000000 +0100
+++ b/data/org.cinnamon.gschema.xml.in	2013-05-22 21:36:04.000000000 +0100
@@ -754,6 +754,23 @@
     </key>
   </schema>
 
+
+  <enum id="bg_style">
+    <value nick="none" value="0"/>
+    <value nick="wallpaper" value="1"/>
+    <value nick="centered" value="2"/>
+    <value nick="scaled" value="3"/>
+    <value nick="stretched" value="4"/>
+    <value nick="zoom" value="5"/>
+    <value nick="spanned" value="6"/>
+  </enum>
+
+  <enum id="bg_shading">
+    <value nick="solid" value="0"/>
+    <value nick="vertical" value="1"/>
+    <value nick="horizontal" value="2"/>
+  </enum>
+
   <schema id="org.cinnamon.background" path="/org/cinnamon/background/">
     <key name="mode" type="s">
       <default>"wallpaper"</default>
@@ -784,8 +801,60 @@
         This key defines the delay for the slideshow.
       </description>
     </key>
+    <key name="draw-background" type="b">
+      <default>true</default>
+      <_summary>Draw Desktop Background</_summary>
+      <_description>Have GNOME draw the desktop background.</_description>
+    </key>
+    <key name="picture-options" enum="bg_style">
+      <default>'zoom'</default>
+      <_summary>Picture Options</_summary>
+      <_description>
+        Determines how the image set by wallpaper_filename is rendered.
+        Possible values are "none", "wallpaper", "centered", "scaled",
+        "stretched", "zoom", "spanned".
+      </_description>
+    </key>
+    <key name="picture-uri" type="s">
+      <default>'file:///usr/share/themes/Adwaita/backgrounds/adwaita-timed.xml'</default>
+      <_summary>Picture URI</_summary>
+      <_description>
+        URI to use for the background image. Not that the backend only supports
+        local (file://) URIs.
+      </_description>
+    </key>
+    <key name="picture-opacity" type="i">
+      <range min="0" max="100"/>
+      <default>100</default>
+      <_summary>Picture Opacity</_summary>
+      <_description>
+        Opacity with which to draw the background picture.
+      </_description>
+    </key>
+    <key name="primary-color" type="s">
+      <default>'#023c88'</default>
+      <_summary>Primary Color</_summary>
+      <_description>
+        Left or Top color when drawing gradients, or the solid color.
+      </_description>
+    </key>
+    <key name="secondary-color" type="s">
+      <default>'#5789ca'</default>
+      <_summary>Secondary Color</_summary>
+      <_description>
+        Right or Bottom color when drawing gradients, not used for solid color.
+      </_description>
+    </key>
+    <key name="color-shading-type" enum="bg_shading">
+      <default>'solid'</default>
+      <_summary>Color Shading Type</_summary>
+      <_description>
+        How to shade the background color. Possible values are "horizontal",
+        "vertical", and "solid".
+      </_description>
+    </key>
   </schema>
-  
+
   <schema id="org.cinnamon.screensaver" path="/org/cinnamon/screensaver/">
     <key name="default-message" type="s">
       <default>""</default>
diff -uNr a/files/usr/bin/cinnamon2d b/files/usr/bin/cinnamon2d
--- a/files/usr/bin/cinnamon2d	2013-05-22 17:35:08.000000000 +0100
+++ b/files/usr/bin/cinnamon2d	2013-05-22 21:36:04.000000000 +0100
@@ -1,2 +1,2 @@
 #!/bin/bash
-CLUTTER_PAINT=disable-clipped-redraws:disable-culling LIBGL_ALWAYS_SOFTWARE=1 CINNAMON_SOFTWARE_RENDERING=1 CINNAMON_SLOWDOWN_FACTOR=0.0001 MUFFIN_NO_SHADOWS=1 CLUTTER_DEFAULT_FPS=15 cinnamon $@
+CLUTTER_DISABLE_XINPUT=1 CLUTTER_PAINT=disable-clipped-redraws:disable-culling LIBGL_ALWAYS_SOFTWARE=1 CINNAMON_SOFTWARE_RENDERING=1 CINNAMON_SLOWDOWN_FACTOR=0.0001 MUFFIN_NO_SHADOWS=1 CLUTTER_DEFAULT_FPS=15 cinnamon $@
diff -uNr a/files/usr/bin/cinnamon3d b/files/usr/bin/cinnamon3d
--- a/files/usr/bin/cinnamon3d	1970-01-01 01:00:00.000000000 +0100
+++ b/files/usr/bin/cinnamon3d	2013-05-22 21:36:04.000000000 +0100
@@ -0,0 +1,2 @@
+#!/bin/bash
+CLUTTER_DISABLE_XINPUT=1 cinnamon $@
diff -uNr a/files/usr/bin/gnome-session-cinnamon b/files/usr/bin/gnome-session-cinnamon
--- a/files/usr/bin/gnome-session-cinnamon	2013-05-22 17:35:08.000000000 +0100
+++ b/files/usr/bin/gnome-session-cinnamon	2013-05-22 21:36:04.000000000 +0100
@@ -1,3 +1,3 @@
 #! /bin/sh
-exec gnome-session --session cinnamon "$@"
+CLUTTER_DISABLE_XINPUT=1 exec gnome-session --session cinnamon "$@"
 
diff -uNr a/files/usr/lib/cinnamon-settings/modules/cs_backgrounds.py b/files/usr/lib/cinnamon-settings/modules/cs_backgrounds.py
--- a/files/usr/lib/cinnamon-settings/modules/cs_backgrounds.py	2013-05-22 17:35:08.000000000 +0100
+++ b/files/usr/lib/cinnamon-settings/modules/cs_backgrounds.py	2013-05-22 21:36:04.000000000 +0100
@@ -232,11 +232,11 @@
     
 
 class BackgroundWallpaperPane (Gtk.VBox):
-    def __init__(self, sidepage, gnome_background_schema):
+    def __init__(self, sidepage, cinnamon_background_schema):
         Gtk.VBox.__init__(self)
         self.set_spacing(5)
         
-        self._gnome_background_schema = gnome_background_schema
+        self._cinnamon_background_schema = cinnamon_background_schema
         self._sidepage = sidepage
         
         scw = Gtk.ScrolledWindow()
@@ -263,15 +263,15 @@
         if wallpaper:
             for key in wallpaper:
                 if key == "filename":
-                    self._gnome_background_schema.set_string("picture-uri", "file://" + wallpaper[key])
+                    self._cinnamon_background_schema.set_string("picture-uri", "file://" + wallpaper[key])
                 elif key == "pcolor":
-                    self._gnome_background_schema.set_string("primary-color", wallpaper[key])
+                    self._cinnamon_background_schema.set_string("primary-color", wallpaper[key])
                 elif key == "scolor":
-                    self._gnome_background_schema.set_string("secondary-color", wallpaper[key])
+                    self._cinnamon_background_schema.set_string("secondary-color", wallpaper[key])
                 elif key == "shade_type":
-                    self._gnome_background_schema.set_string("color-shading-type", wallpaper[key])
+                    self._cinnamon_background_schema.set_string("color-shading-type", wallpaper[key])
                 elif key == "options":
-                    self._gnome_background_schema.set_string("picture-options", wallpaper[key])
+                    self._cinnamon_background_schema.set_string("picture-options", wallpaper[key])
             if (not "metadataFile" in wallpaper) or (wallpaper["metadataFile"] == ""):
                 self._sidepage.remove_wallpaper_button.set_sensitive(True)
     
@@ -365,7 +365,7 @@
         return res
 
 class BackgroundSlideshowPane(Gtk.Table):
-    def __init__(self, sidepage, gnome_background_schema, cinnamon_background_schema):
+    def __init__(self, sidepage, cinnamon_background_schema):
         Gtk.Table.__init__(self)
         self.set_col_spacings(5)
         self.set_row_spacings(5)
@@ -446,12 +446,11 @@
             f = open(filename, "w")
             f.write(xml_data)
             f.close()
-            Gio.Settings("org.gnome.desktop.background").set_string("picture-uri", "file://" + filename)
+            Gio.Settings("org.cinnamon.background").set_string("picture-uri", "file://" + filename)
 
 class BackgroundSidePage (SidePage):
     def __init__(self, name, icon, keywords, advanced, content_box):
         SidePage.__init__(self, name, icon, keywords, advanced, content_box, -1)
-        self._gnome_background_schema = Gio.Settings("org.gnome.desktop.background")
         self._cinnamon_background_schema = Gio.Settings("org.cinnamon.background")
         self._add_wallpapers_dialog = AddWallpapersDialog()
         
@@ -516,8 +515,8 @@
         self.mainbox.set_visible_window(False)
         self.content_box.pack_start(self.mainbox, True, True, 3)
         
-        self.wallpaper_pane = BackgroundWallpaperPane(self, self._gnome_background_schema)
-        self.slideshow_pane = BackgroundSlideshowPane(self, self._gnome_background_schema, self._cinnamon_background_schema)
+        self.wallpaper_pane = BackgroundWallpaperPane(self, self._cinnamon_background_schema)
+        self.slideshow_pane = BackgroundSlideshowPane(self, self._cinnamon_background_schema)
         if self._cinnamon_background_schema["mode"] == "slideshow":
             self.mainbox.add(self.slideshow_pane)
         else:
@@ -537,21 +536,21 @@
         l = Gtk.Label(_("Picture aspect"))
         l.set_alignment(0, 0.5)
         advanced_options_box.pack_start(l, False, False, 0)
-        self.picture_options = GSettingsComboBox("", "org.gnome.desktop.background", "picture-options", None, BACKGROUND_PICTURE_OPTIONS)
+        self.picture_options = GSettingsComboBox("", "org.cinnamon.background", "picture-options", None, BACKGROUND_PICTURE_OPTIONS)
         advanced_options_box.pack_start(self.picture_options, False, False, 0)
         
         l = Gtk.Label(_("Gradient"))
         l.set_alignment(0, 0.5)
         advanced_options_box.pack_start(l, False, False, 0)
-        self.color_shading_type = GSettingsComboBox("", "org.gnome.desktop.background", "color-shading-type", None, BACKGROUND_COLOR_SHADING_TYPES)
+        self.color_shading_type = GSettingsComboBox("", "org.cinnamon.background", "color-shading-type", None, BACKGROUND_COLOR_SHADING_TYPES)
         advanced_options_box.pack_start(self.color_shading_type, False, False, 0)
         
         hbox = Gtk.HBox()
         l = Gtk.Label(_("Colors"))
         hbox.pack_start(l, False, False, 2)
-        self.primary_color = GSettingsColorChooser("org.gnome.desktop.background", "primary-color", None)
+        self.primary_color = GSettingsColorChooser("org.cinnamon.background", "primary-color", None)
         hbox.pack_start(self.primary_color, False, False, 2)
-        self.secondary_color = GSettingsColorChooser("org.gnome.desktop.background", "secondary-color", None)
+        self.secondary_color = GSettingsColorChooser("org.cinnamon.background", "secondary-color", None)
         hbox.pack_start(self.secondary_color, False, False, 2)
         advanced_options_box.pack_start(hbox, False, False, 0)
         self.content_box.show_all()
diff -uNr a/files/usr/lib/cinnamon-settings/modules/cs_keyboard.py b/files/usr/lib/cinnamon-settings/modules/cs_keyboard.py
--- a/files/usr/lib/cinnamon-settings/modules/cs_keyboard.py	2013-05-22 17:35:08.000000000 +0100
+++ b/files/usr/lib/cinnamon-settings/modules/cs_keyboard.py	2013-05-22 21:36:04.000000000 +0100
@@ -42,8 +42,8 @@
     # Cinnamon stuff
     [_("Toggle Scale"), "org.gnome.desktop.wm.keybindings", "switch-to-workspace-down", True, "cinnamon"],
     [_("Toggle Expo"), "org.gnome.desktop.wm.keybindings", "switch-to-workspace-up", True, "cinnamon"],
-    [_("Cycle through open windows"), "org.gnome.desktop.wm.keybindings", "switch-windows", True, "cinnamon"],
-    [_("Cycle backwards though open windows"), "org.gnome.desktop.wm.keybindings", "switch-windows-backward", True, "cinnamon"],
+    [_("Cycle through open windows"), "org.gnome.desktop.wm.keybindings", "switch-applications", True, "cinnamon"],
+    [_("Cycle backwards though open windows"), "org.gnome.desktop.wm.keybindings", "switch-applications-backward", True, "cinnamon"],
     [_("Run dialog (must restart Cinnamon)"), "org.gnome.desktop.wm.keybindings", "panel-run-dialog", True, "cinnamon"],
     [_("Menu button (must restart Cinnamon)"), "org.cinnamon.muffin", "overlay-key", False, "cinnamon"],
 
diff -uNr a/files/usr/share/cinnamon/applets/brightness@cinnamon.org/applet.js b/files/usr/share/cinnamon/applets/brightness@cinnamon.org/applet.js
--- a/files/usr/share/cinnamon/applets/brightness@cinnamon.org/applet.js	2013-05-22 17:35:08.000000000 +0100
+++ b/files/usr/share/cinnamon/applets/brightness@cinnamon.org/applet.js	2013-05-22 21:36:04.000000000 +0100
@@ -5,7 +5,6 @@
 const PopupMenu = imports.ui.popupMenu;
 const GLib = imports.gi.GLib;
 const Gio = imports.gi.Gio;
-const DBus = imports.dbus;
 
 /* constants */
 const DimSettingsSchema = "org.gnome.settings-daemon.plugins.power";
@@ -14,24 +13,25 @@
 const PowerBusName = 'org.gnome.SettingsDaemon';
 const PowerObjectPath = '/org/gnome/SettingsDaemon/Power';
 
-/* DBus interface */
-const PowerManagerInterface = {
-    name: 'org.gnome.SettingsDaemon.Power.Screen',
-    methods:
-        [
-            { name: 'GetPercentage', inSignature: '', outSignature: 'u' },
-            { name: 'SetPercentage', inSignature: 'u', outSignature: 'u' },
-            { name: 'StepUp', inSignature: '', outSignature: 'u' },
-            { name: 'StepDown', inSignature: '', outSignature: 'u' },
-        ],
-    signals:
-        [
-            { name: 'Changed', inSignature: '', outSignature: '' },
-        ]
-};
+const PowerManagerInterface = <interface name="org.gnome.SettingsDaemon.Power.Screen">
+<method name="GetPercentage">
+    <arg type="u" direction="out"/>
+</method>
+<method name="SetPercentage">
+    <arg type="u" direction="in"/>
+    <arg type="u" direction="out"/>
+</method>
+<method name="StepUp">
+    <arg type="u" direction="out"/>
+</method>
+<method name="StepDown">
+    <arg type="u" direction="out"/>
+</method>
+<signal name="Changed" />
+</interface>;
 
 /* DBus magic */
-let PowerManagerProxy = DBus.makeProxyClass(PowerManagerInterface);
+const PowerManagerProxy = Gio.DBusProxy.makeProxyWrapper(PowerManagerInterface);
 
 /* TextImageMenuItem taken from sound@cinnamon.org applet */
 let icon_path = "/usr/share/cinnamon/theme/";
@@ -100,7 +100,7 @@
         Applet.IconApplet.prototype._init.call(this, orientation, panel_height);
         
         try {
-            this._proxy = new PowerManagerProxy(DBus.session, PowerBusName, PowerObjectPath);
+            this._proxy = new PowerManagerProxy(Gio.DBus.session, PowerBusName, PowerObjectPath);
             
             this.menuManager = new PopupMenu.PopupMenuManager(this);
             this.menu = new Applet.AppletPopupMenu(this, orientation);
@@ -137,7 +137,8 @@
                     this.menu.addMenuItem(this._settingsMenu);
                 
                     //get notified
-                    this._proxy.connect('Changed', Lang.bind(this, this._getBrightness));
+                    this._proxy.connectSignal('Changed', Lang.bind(this, this._getBrightness));
+                    
                     this.actor.connect('scroll-event', Lang.bind(this, this._onScrollEvent));
                 } else {
                     this.set_applet_tooltip(_("Brightness"));
diff -uNr a/files/usr/share/cinnamon/applets/power@cinnamon.org/applet.js b/files/usr/share/cinnamon/applets/power@cinnamon.org/applet.js
--- a/files/usr/share/cinnamon/applets/power@cinnamon.org/applet.js	2013-05-22 17:35:08.000000000 +0100
+++ b/files/usr/share/cinnamon/applets/power@cinnamon.org/applet.js	2013-05-22 21:36:04.000000000 +0100
@@ -1,6 +1,5 @@
 const Applet = imports.ui.applet;
 const Gio = imports.gi.Gio;
-const DBus = imports.dbus;
 const Lang = imports.lang;
 const St = imports.gi.St;
 const PopupMenu = imports.ui.popupMenu;
@@ -42,34 +41,17 @@
     TIME: 'time'
 };
 
-const PowerManagerInterface = {
-    name: 'org.gnome.SettingsDaemon.Power',
-    methods: [
-        { name: 'GetDevices', inSignature: '', outSignature: 'a(susdut)' },
-        { name: 'GetPrimaryDevice', inSignature: '', outSignature: '(susdut)' },
-        ],
-    signals: [
-        { name: 'PropertiesChanged', inSignature: 's,a{sv},a[s]' },
-        ],
-    properties: [
-        { name: 'Icon', signature: 's', access: 'read' },
-        ]
-};
-let PowerManagerProxy = DBus.makeProxyClass(PowerManagerInterface);
-
-const SettingsManagerInterface = {
-	name: 'org.freedesktop.DBus.Properties',
-	methods: [
-		{ name: 'Get', inSignature: 's,s', outSignature: 'v' },
-		{ name: 'GetAll', inSignature: 's', outSignature: 'a{sv}' },
-		{ name: 'Set', inSignature: 's,s,v', outSignature: '' }
-	],
-	signals: [
-	{name: 'PropertiesChanged', inSignature:'s,a{sv},a[s]', outSignature:''}
-	]
-};
+const PowerManagerInterface = <interface name="org.gnome.SettingsDaemon.Power">
+<method name="GetDevices">
+    <arg type="a(susdut)" direction="out"/>
+</method>
+<method name="GetPrimaryDevice">
+    <arg type="(susdut)" direction="out"/>
+</method>
+<property name="Icon" type="s" access="read" />
+</interface>;
 
-let SettingsManagerProxy = DBus.makeProxyClass(SettingsManagerInterface);
+const PowerManagerProxy = Gio.DBusProxy.makeProxyWrapper(PowerManagerInterface);
 
 function DeviceItem() {
     this._init.apply(this, arguments);
@@ -143,11 +125,19 @@
             this.menuManager = new PopupMenu.PopupMenuManager(this);
             this.menu = new Applet.AppletPopupMenu(this, orientation);
             this.menuManager.addMenu(this.menu);            
-            
+
             //this.set_applet_icon_symbolic_name('battery-missing');            
-            this._proxy = new PowerManagerProxy(DBus.session, BUS_NAME, OBJECT_PATH);
-            this._smProxy = new SettingsManagerProxy(DBus.session, BUS_NAME, OBJECT_PATH);
-            
+            this._proxy = new PowerManagerProxy(Gio.DBus.session, BUS_NAME, OBJECT_PATH,
+                                               Lang.bind(this, function(proxy, error) {
+                                                             if (error) {
+                                                                 global.log(error.message);
+
+                                                                 return;
+                                                             }
+                                                             this._proxy.connect('g-properties-changed', Lang.bind(this, this._devicesChanged));
+                                                             this._devicesChanged();
+                                               }));
+
             let icon = this.actor.get_children()[0];
             this.actor.remove_actor(icon);
             let box = new St.BoxLayout({ name: 'batteryBox' });
@@ -200,9 +190,6 @@
 
             this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
             this.menu.addSettingsAction(_("Power Settings"), 'power');
-
-            this._smProxy.connect('PropertiesChanged', Lang.bind(this, this._devicesChanged));
-            this._devicesChanged();            
         }
         catch (e) {
             global.logError(e);
@@ -234,14 +221,14 @@
     },
     
     _readPrimaryDevice: function() {
-        this._proxy.GetPrimaryDeviceRemote(Lang.bind(this, function(device, error) {
+        this._proxy.GetPrimaryDeviceRemote(Lang.bind(this, function(result, error) {
             if (error) {
                 this._hasPrimary = false;
                 this._primaryDeviceId = null;
                 this._batteryItem.actor.hide();                
                 return;
             }
-            let [device_id, device_type, icon, percentage, state, seconds] = device;
+            let [[device_id, device_type, icon, percentage, state, seconds]] = result;
             if (device_type == UPDeviceType.BATTERY) {
                 this._hasPrimary = true;
                 let time = Math.round(seconds / 60);
@@ -279,7 +266,7 @@
     },
 
     _readOtherDevices: function() {
-        this._proxy.GetDevicesRemote(Lang.bind(this, function(devices, error) {
+        this._proxy.GetDevicesRemote(Lang.bind(this, function([devices], error) {
             this._deviceItems.forEach(function(i) { i.destroy(); });
             this._deviceItems = [];
 
@@ -306,25 +293,26 @@
         this._devicesChanged();
     },
 
-    _devicesChanged: function() {        
-        this._proxy.GetRemote('Icon', Lang.bind(this, function(icon, error) {
-            if (icon) {    
-                this.set_applet_icon_symbolic_name('battery-missing');
-                let gicon = Gio.icon_new_for_string(icon);
-                this._applet_icon.gicon = gicon;
-                this.actor.show();
-            } else {
-                this.menu.close();
-                this.actor.hide();
-            }
-        }));
+
+    _devicesChanged: function() {
+        this.set_applet_icon_symbolic_name('battery-missing');
+        let icon = this._proxy.Icon;
+        if (icon) {
+            let gicon = Gio.icon_new_for_string(icon);
+            this._applet_icon.gicon = gicon
+            this.actor.show();
+        } else {
+            this.menu.close();
+            this.actor.hide();
+        }
+
         this._readPrimaryDevice();
         this._readOtherDevices();
         this._updateLabel();
     },
     
     _updateLabel: function() {
-        this._proxy.GetDevicesRemote(Lang.bind(this, function(devices, error) {
+        this._proxy.GetDevicesRemote(Lang.bind(this, function([devices], error) {
             if (error) {
                 this._mainLabel.set_text("");
                 return;
